% Chap.3 M3_3
clc; clear all; close all;

c_light = 2.99793e-7;       %[km/ps] speed of light

% Generate the V number for plotting

V = linspace(0,3,200);
b = 1-(1+sqrt(2))^2./(1+(4+V.^4).^.25).^2;

dVb_dV = diff(V.*b)./diff(V);
% diff(V) will have one less element than V,
% so we must truncate the other vectors appropriately

V=V(1:199);
Vd2Vb_dV2 = V(1:198).*diff(dVb_dV)./diff(V);
b=b(1:198);

% truncate the vectors to have the same length to plot

dVb_dV = dVb_dV(1:198);
V=V(1:198);

figure(1)
plot(V,b,'k-.',V,dVb_dV,'b:',V,Vd2Vb_dV2,'r')
legend('b','d(Vb)/dV','Vd^2(Vb)/d^2V')
xlabel('ȭ ļ V')

figure(2)
plot(V,Vd2Vb_dV2,'r')
%legend('Vd^2(Vb)/d^2V')
xlabel('ȭ ļ V')
hold on

clear all

V = linspace(1.5,2.5,200);
b = (1.1428-0.9960./V).^2; % Eq.(2-80)

dVb_dV = diff(V.*b)./diff(V);
V=V(1:199);
Vd2Vb_dV2 = V(1:198).*diff(dVb_dV)./diff(V);
b=b(1:198);

dVb_dV = dVb_dV(1:198);
V=V(1:198);

figure(2)
plot(V,Vd2Vb_dV2,'r:')
title('Vd^2(Vb)/d^2V ')


