% This is to plot bessel functions

x=0:.1:20;

% 1.Jm(x) Bessel function of the first kind

fj0 = besselj(0,x);
fj1 = besselj(1,x);
fj2 = besselj(2,x);
%fj3 = besselj(3,x);

figure(1)
plot(x,fj0,'r-',x,fj1,'g-.',x,fj2,'b:')
xlabel('x'); ylabel('J_m(x)')
title('Bessel function of the first kind')
grid on
axis([0 20 -0.42 1.1])

% 2. Ym(x) Bessel function of the second kind

fy0 = bessely(0,x);
fy1 = bessely(1,x);
fy2 = bessely(2,x);
%fy3 = bessely(3,x);

figure(2)
plot(x,fy0,'r-',x,fy1,'g-.',x,fy2,'b:')
xlabel('x'); ylabel('Y_m(x)')
title('Bessel function of the second kind')

grid on
axis([0 15 -2.2 1.1])

% 3. Im(x) Modified Bessel function of the first kind
x2=0:0.02:4;

fi0 = besseli(0,x2);
fi1 = besseli(1,x2);
fi2 = besseli(2,x2);
fi3 = besseli(3,x2);

figure(3)
plot(x2,fi0,'r-',x2,fi1,'g-.',x2,fi2,'b:',x2,fi3,'k--')
xlabel('x'); ylabel('I_m(x)')
title('Modified Bessel function of the first kind')

grid on
axis([0 4 -0.2 3.7])

% 4. Km(x) Modified Bessel function of the second kind

fk0 = besselk(0,x2);
fk1 = besselk(1,x2);
fk2 = besselk(2,x2);
fk3 = besselk(3,x2);

figure(4)
plot(x2,fk0,'r-',x2,fk1,'g-.',x2,fk2,'b:',x2,fk3,'k--')
xlabel('x'); ylabel('K_m(x)')
title('Modified Bessel function of the second kind')

grid on
axis([0 4 -0.2 3.7])