% Fig8-11

clear all ;% clear all variables
close all
%============== Define global variables ===================================================
global BitRate Bits2Power Bits TimeWindow SampleRate DataLength samplesperbit t_range f_sym Ref_Frequency

BitRate = 1e9;  
Bits2Power = 5;
Bits = 2^Bits2Power;
TimeWindow = Bits/BitRate;
SampleRate = BitRate*2^10;
DataLength = TimeWindow*SampleRate;
Ref_Frequency = 193.1e12; %[Hz] Reference optical frequency
samplesperbit = SampleRate/BitRate; % data number per bit

% time, optical frequency range
t_range = 0:1/SampleRate:1/SampleRate*(DataLength-1);
f_sym = SampleRate*(-DataLength/2:(DataLength/2-1))/DataLength; %

%==========================================================================================
%=================== Define Simulation Blocks =============================================
% SM Laser
UnmodulatedPower = 2e-3; %[W] 
Linewidth = 10e6; %[Hz]
Laser1 = LaserCW(UnmodulatedPower,Linewidth);
%------------- Data Source -------------------%
PreSpaces = 2;  %number of leading zero bits
PostSpaces = 2; %number of trailing zero bits
info_bits = infobits_PRBS(PreSpaces,PostSpaces);

E_data = NRZCoder(info_bits);

ERiseTime = 1/4/BitRate; %  In the form of k/BitRate, k should be less than (1/2)*RZRatio if RZCoder used   
E_elec = RiseTimeAdjust(E_data,ERiseTime);

ModulationIndex = 0.9; ChirpFactor = 0;
%mod_out = ModulatorAmplitude(LaserCW,E_elec, 0.9);
%mod_out = Modulator_Mach_Zehnder(LaserCW,E_elec);
mod_out = ModulatorElectroabsorp(LaserCW,E_elec,ModulationIndex,ChirpFactor);
%-----------------------------------------------------
figure(1)
plot(t_range,abs(mod_out).^2)

%figure(2)
y = OpticalSpectrumAnalyzer(mod_out);

