% Fig8-12
clear all ;% clear all variables
close all

%============== Define global variables ===================================================
global BitRate Bits SampleRate samplesperbit 

BitRate = 1e9;  
Bits2Power = 4;
Bits = 2^Bits2Power;
TimeWindow = Bits/BitRate;
SampleRate = BitRate*2^10;
DataLength = TimeWindow*SampleRate;
Ref_Frequency = 193.1e12; %[Hz] Reference optical frequency
samplesperbit = SampleRate/BitRate; % data number per bit

% time, optical frequency range
t_range = 0:1/SampleRate:1/SampleRate*(DataLength-1);
f_sym = SampleRate*(-DataLength/2:(DataLength/2-1))/DataLength; %

%==========================================================================================

%=================== Define Simulation Blocks =============================================

%------------- Data Source -------------------%
PreSpaces = 2;  %number of leading zero bits
PostSpaces = 2; %number of trailing zero bits
info_bits = infobits_PRBS(PreSpaces,PostSpaces);
%-- Gaussian Pulse Generator  ---------------------------------------------
fwhm = 1/3/BitRate; 
PeakPower = 10e-3;% [W] 
CenterPosition = 0;% Relative position of the pulse peak wrt bit frame  %[-0.5 0.5] default = 0 (center)
GaussianOrder = 1; %  Order of super-Gaussain function, default = 1 (Gaussian)
Chirp = 0; %  Chirp factor default = 0
ExcessPulseSlots = 3;% Number of extra bit slot to consider neighboring bits, default = 3;
%
mod_out1 = PulseGaussianOptical(info_bits,PeakPower,fwhm,GaussianOrder,Chirp,...
                                  ExcessPulseSlots,CenterPosition); 
mod_out2 = PulseSechantOptical(info_bits,PeakPower,fwhm,ExcessPulseSlots,CenterPosition); 
%-----------------------------------------------------
         
figure(1)
plot(t_range,abs(mod_out1).^2)

figure(2)
plot(t_range,abs(mod_out2).^2)

%figure(2)
OpticalSpectrumAnalyzer(mod_out1);
OpticalSpectrumAnalyzer(mod_out2);



